app.Models.Candidate =  Backbone.Model.extend({
	defaults: {
        ip: '',
        port: '',
        failover: false
    },

    
    ping: function(callback, attempt) {
    	var tStart = new Date().getTime();
    	attempt = attempt || 1;
    	jQuery.ajax({
			url: (this.get('port') === '443' ? 'https' : 'http') + '://' + this.getHost() + '/api/v1/PBX/ping/',
            type: "GET",
            timeout: 3000,
            success: function(data, status) {
            	console.log(new Date().toLocaleString() + ' :: ping '+this.getHost()+' '+ ((new Date().getTime() - tStart)/1000) + 's :: success ');
            	callback('pong');
            }.bind(this),
            error: function(e){
            	attempt --;
            	console.log(new Date().toLocaleString() + ' :: ping '+this.getHost()+' '+ ((new Date().getTime() - tStart)/1000) + 's :: error ', e);
            	if(attempt == 0){
            		callback('error');
            	}else{
            		setTimeout(jQuery.proxy(this.ping, this, callback, attempt), 5000);// 5 seconds
            	}
            	
            }.bind(this)
    	});

    },

    getHost: function(){
    	return this.get('ip') + ':' + this.get('port');
    },
    
    _local: undefined,
    isLocal: function(){
    	if(this._local === undefined){
    		this._local = this.get('ip').search(/^(10\.)|(172\.)|(192\.)/) != -1;
    	}
    	return this._local;
    },
    
    _domain: undefined,
    isDomain: function(){
    	if(this._domain === undefined){
    		this._domain = this.get('ip').search(/^[\d\.]*$/) == -1;
    	}
    	return this._domain;
    },
    
    isFailover: function(){
    	return this.get('failover');
    }
});
