
window.addEventListener("load", function(){

	/*
	 * first start extension after install or update
	 */

	chrome.runtime.onInstalled.addListener(function(details){
		if(details.reason == 'update' || details.reason == 'install'){

			// fix load content script in an already open tabs after update or install extension

			var manifest = chrome.runtime.getManifest();
			var cs = [];
			for(var i = 0; i < manifest['content_scripts'].length; i++){
				cs[i] = {
						'matches': new RegExp('(' + manifest['content_scripts'][i]['matches'].join(')|(').replace(/\*/g, '.*') + ')'),
						'js': manifest['content_scripts'][i]['js']
				}
				if(manifest['content_scripts'][i]['exclude_matches']){
					cs[i]['exclude_matches'] = new RegExp('(' + manifest['content_scripts'][i]['exclude_matches'].join(')|(').replace(/\*/g, '.*') + ')');
				}
			}
			var cs_count = cs.length;
			chrome.windows.getAll({populate:true} ,function(allWindows){
				var url;
	    		for(var i in allWindows){
	    			for(var j in allWindows[i].tabs){
	    				url = allWindows[i].tabs[j].url;
	    				for(var k = 0; k < cs_count; k++ ){
	    					if(url.search(cs[k]['matches']) != -1 && (! cs[k]['exclude_matches'] || url.search(cs[k]['exclude_matches']) == -1)){
	    						cs[k]['js'].forEach(function(js){
		    						chrome.tabs.executeScript(allWindows[i].tabs[j].id, {file: js});
	    						});
		    				}
	    				}
	    			}
	    		}
	    		app.init();
	    	});
		}
	});

	/*
	 * first start extension after restart chrome
	 */

	chrome.runtime.onStartup.addListener(function(){
		app.init();
	})


});