/**
 *
 * fix first load device
 * after check device send message to extension value selected device
 */

//create an observer instance
var observer = new MutationObserver(function(e) {
	e.forEach(function(at){
		if(at.attributeName == 'title'){
			var phone = $('.selectionPhones input:checked').val();
			if(phone){
				chrome.runtime.sendMessage({cmd: 'getDevice', data: phone});
			}
		}
	});

});

//********** start************
if(document.readyState == 'complete'){
	window.postMessage({cmd: "loadExtension"}, window.location.origin);

}else{
	window.addEventListener("load", function(){
		window.postMessage({cmd: "loadExtension"}, window.location.origin);
		var ph = $('#click2call_btn').find('.ui-button-text')[0];
		if(ph){
			observer.observe(ph, {attributes: true});
		}
	});
}

/**
 * Listen Post messages on window
 * from collaboration
 * and passes it to the extension
 */
window.addEventListener("message", function(event) {

	if(event.origin && event.origin != window.location.origin){
		return;
	}
	
	if(event.data){
		var cmd;
		if(typeof(event.data) == 'string'){
			cmd = event.data;
		}else{
			cmd = event.data.cmd;
		}
		switch(cmd){
			case "issetExtensionCollaboration":
				window.postMessage({cmd: "issetExtensionCollaborationResponse"}, window.location.origin);
			break;
			case "appWindowFocus":
				chrome.runtime.sendMessage({cmd: 'focus', url: event.data.data});
			break;
			case "connect":
				chrome.runtime.sendMessage({cmd: 'tabConnect'});
			break;
			case "disconnect":
				chrome.runtime.sendMessage({cmd: 'tabDisconnect'});
			break;
		}
	}
});

// message passing on extension

chrome.runtime.onMessage.addListener(function(request, sender, callback){

	var cmd;
	if(typeof(request) == 'string'){
		cmd = request;
	}else{
		cmd = request.cmd;
	}

	switch(cmd){
		case 'getSettings':
			callback({
				user: getTextFromHtml('myNickname')
			});
			break;
		case 'getDevice':
			var phone = document.querySelector('.selectionPhones input:checked');

			if(phone){
				chrome.runtime.sendMessage({cmd: 'getDevice', data: phone.getAttribute('value')});
			}else{
				setTimeout(function(){
					//if the device is not loaded in 10 seconds to return null
					// fix first loaded device code below
					phone = $('.selectionPhones input:checked').val();
					chrome.runtime.sendMessage({cmd: 'getDevice', data: phone || null});
				}, 10000);
			}

			break;
		case 'getVersion':
			getVersion();
			break;

	}
});

var getTextFromHtml = function(id){
	var dom = document.getElementById(id);
	if(dom){
		return dom.innerHTML;
	}else{
		return null;
	}
}

var getVersion = function(){
    jQuery.ajax({
        url: window.location.protocol + '//' + window.location.host + '/api/v1/PBX/version/' ,
        headers: {'UA': 'chromeExtension'},
        type: "GET",
        timeout: 3000,
        success: function(response){
            let version = 0;
            if (response && 'result' in response) {
            	version = response.result.split('~')[0];
            }
            chrome.runtime.sendMessage({cmd: 'getVersion', data: version});
        },
        error: function(){
            console.log('error');
            chrome.runtime.sendMessage({cmd: 'getVersion', data: 0});
        }
    });
}
